#pragma once

/* Icons */
#define IDI_MAIN                 10
#define IDI_EXIT                 11
#define IDI_INSTALL              12
#define IDI_UNINSTALL            13
#define IDI_SETTINGS             14
#define IDI_MODIFY               15
#define IDI_REFRESH              16
#define IDI_APPS                 17
#define IDI_APPUPD               18
#define IDI_CATEGORY             19

/* Icons for categories */
#define IDI_CAT_AUDIO            50
#define IDI_CAT_DEVEL            51
#define IDI_CAT_DRIVERS          52
#define IDI_CAT_EDU              53
#define IDI_CAT_ENGINEER         54
#define IDI_CAT_FINANCE          55
#define IDI_CAT_GAMES            56
#define IDI_CAT_GRAPHICS         57
#define IDI_CAT_INTERNET         58
#define IDI_CAT_LIBS             59
#define IDI_CAT_OFFICE           60
#define IDI_CAT_OTHER            61
#define IDI_CAT_SCIENCE          62
#define IDI_CAT_TOOLS            63
#define IDI_CAT_VIDEO            64

/* Bitmaps */

/* Controls */
#define IDC_STATUSBAR            1000
#define IDC_DOWNLOAD_PROGRESS    1001
#define IDC_DOWNLOAD_STATUS      1002
#define IDC_SAVE_WINDOW_POS      1003
#define IDC_UPDATE_AVLIST        1004
#define IDC_DOWNLOAD_DIR_EDIT    1005
#define IDC_DEL_AFTER_INSTALL    1006
#define IDC_LOG_ENABLED          1007
#define IDC_CHOOSE               1008
#define IDC_DEFAULT_SETTINGS     1009
#define IDC_INSTALL_TEXT         1010
#define IDC_CD_INSTALL           1011
#define IDC_DOWNLOAD_INSTALL     1012

/* Dialogs */
#define IDD_SETTINGS_DIALOG      300
#define IDD_INSTALL_DIALOG       301
#define IDD_DOWNLOAD_DIALOG      302
#define IDD_ABOUT_DIALOG         303

/* Menus */
#define IDR_MAINMENU             500
#define IDR_LINKMENU             501
#define IDR_APPLICATIONMENU      502

/* Menu items */
#define ID_EXIT                  550
#define ID_INSTALL               551
#define ID_UNINSTALL             552
#define ID_HELP                  553
#define ID_ABOUT                 554
#define ID_MODIFY                555
#define ID_OPEN_LINK             556
#define ID_COPY_LINK             557
#define ID_SETTINGS              558
#define ID_REFRESH               559
#define ID_REGREMOVE             560

/* Strings */
#define IDS_APPTITLE             100
#define IDS_SEARCH_TEXT          101
#define IDS_INSTALL              102
#define IDS_UNINSTALL            103
#define IDS_MODIFY               104
#define IDS_APPS_COUNT           105
#define IDS_WELCOME_TITLE        106
#define IDS_WELCOME_TEXT         107
#define IDS_WELCOME_URL          108
#define IDS_INSTALLED            109
#define IDS_AVAILABLEFORINST     110
#define IDS_UPDATES              111
#define IDS_APPLICATIONS         112
#define IDS_CHOOSE_FOLDER_TEXT   113
#define IDS_CHOOSE_FOLDER_ERROR  114
#define IDS_USER_NOT_ADMIN       115
#define IDS_APP_REG_REMOVE       116
#define IDS_INFORMATION          117
#define IDS_UNABLE_TO_REMOVE     118

/* Tooltips */
#define IDS_TOOLTIP_INSTALL      200
#define IDS_TOOLTIP_UNINSTALL    201
#define IDS_TOOLTIP_MODIFY       202
#define IDS_TOOLTIP_SETTINGS     203
#define IDS_TOOLTIP_REFRESH      204
#define IDS_TOOLTIP_EXIT         205

/* Columns info */
#define IDS_APP_NAME             250
#define IDS_APP_INST_VERSION     251
#define IDS_APP_DESCRIPTION      252

/* Apps info */
#define IDS_INFO_VERSION         280
#define IDS_INFO_DESCRIPTION     281
#define IDS_INFO_PUBLISHER       282
#define IDS_INFO_HELPLINK        283
#define IDS_INFO_HELPPHONE       284
#define IDS_INFO_README          285
#define IDS_INFO_REGOWNER        286
#define IDS_INFO_PRODUCTID       287
#define IDS_INFO_CONTACT         288
#define IDS_INFO_UPDATEINFO      289
#define IDS_INFO_INFOABOUT       290
#define IDS_INFO_COMMENTS        291
#define IDS_INFO_INSTLOCATION    292
#define IDS_INFO_INSTALLSRC      293
#define IDS_INFO_UNINSTALLSTR    294
#define IDS_INFO_MODIFYPATH      295
#define IDS_INFO_INSTALLDATE     296

/* Info for availabled apps */
#define IDS_AINFO_VERSION        350
#define IDS_AINFO_DESCRIPTION    351
#define IDS_AINFO_SIZE           352
#define IDS_AINFO_URLSITE        353
#define IDS_AINFO_LICENCE        354

/* Names of categories */
#define IDS_CAT_AUDIO            700
#define IDS_CAT_DEVEL            701
#define IDS_CAT_DRIVERS          702
#define IDS_CAT_EDU              703
#define IDS_CAT_ENGINEER         704
#define IDS_CAT_FINANCE          705
#define IDS_CAT_GAMES            706
#define IDS_CAT_GRAPHICS         707
#define IDS_CAT_INTERNET         708
#define IDS_CAT_LIBS             709
#define IDS_CAT_OFFICE           710
#define IDS_CAT_OTHER            711
#define IDS_CAT_SCIENCE          712
#define IDS_CAT_TOOLS            713
#define IDS_CAT_VIDEO            714

/* Other */
#ifndef IDC_STATIC
#define IDC_STATIC               -1
#endif
