/*
 * Copyright 2000 Juergen Schmied
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#ifndef __WINE_SHELL_RES_H
#define __WINE_SHELL_RES_H

#define IDC_STATIC                  -1

/*
 * Bitmaps
 */
#define IDB_SHELL_ABOUT_LOGO_24BPP  131

/*
 * Strings
 */

/* Column titles for the shellview */
#define IDS_SHV_COLUMN1             7
#define IDS_SHV_COLUMN2             8
#define IDS_SHV_COLUMN3             9
#define IDS_SHV_COLUMN4             10
#define IDS_SHV_COLUMN5             11
#define IDS_SHV_COLUMN6             12
#define IDS_SHV_COLUMN7             13
#define IDS_SHV_COLUMN8             14
#define IDS_SHV_COLUMN9             15
#define IDS_SHV_COLUMN10            16
#define IDS_SHV_COLUMN11            17
#define IDS_SHV_COLUMN_DELFROM      18
#define IDS_SHV_COLUMN_DELDATE      19

#define IDS_DESKTOP                 20

#define IDS_SELECT                  22
#define IDS_OPEN                    23
#define IDS_VIEW_LARGE              24
#define IDS_VIEW_SMALL              25
#define IDS_VIEW_LIST               26
#define IDS_VIEW_DETAILS            27

#define IDS_RESTART_TITLE           40
#define IDS_RESTART_PROMPT          41
#define IDS_SHUTDOWN_TITLE          42
#define IDS_SHUTDOWN_PROMPT         43

#define IDS_PROGRAMS                45
#define IDS_FAVORITES               47
#define IDS_STARTUP                 48
#define IDS_RECENT                  49
#define IDS_SENDTO                  50
#define IDS_STARTMENU               51
#define IDS_MYMUSIC                 52
#define IDS_MYVIDEO                 53
#define IDS_DESKTOPDIRECTORY        54
#define IDS_NETHOOD                 55
#define IDS_TEMPLATES               56
#define IDS_APPDATA                 57
#define IDS_PRINTHOOD               58
#define IDS_LOCAL_APPDATA           59
#define IDS_INTERNET_CACHE          60
#define IDS_COOKIES                 61
#define IDS_HISTORY                 62
#define IDS_PROGRAM_FILES           63
#define IDS_MYPICTURES              64
#define IDS_PROGRAM_FILES_COMMON    65
#define IDS_COMMON_DOCUMENTS        66
#define IDS_ADMINTOOLS              67
#define IDS_COMMON_MUSIC            68
#define IDS_COMMON_PICTURES         69
#define IDS_COMMON_VIDEO            70
#define IDS_CDBURN_AREA             71
#define IDS_DRIVE_FIXED             72
#define IDS_DRIVE_CDROM             73
#define IDS_DRIVE_NETWORK           74

#define IDS_LOGOFF_TITLE            78
#define IDS_LOGOFF_PROMPT           79

#define IDS_CREATEFOLDER_DENIED     128
#define IDS_CREATEFOLDER_CAPTION    129
#define IDS_DELETEITEM_CAPTION      130
#define IDS_DELETEFOLDER_CAPTION    131
#define IDS_DELETEITEM_TEXT         132
#define IDS_DELETEMULTIPLE_TEXT     133
#define IDS_OVERWRITEFILE_CAPTION   134
#define IDS_OVERWRITEFILE_TEXT      135
#define IDS_DELETESELECTED_TEXT     136
#define IDS_TRASHFOLDER_TEXT        137
#define IDS_TRASHITEM_TEXT          138
#define IDS_TRASHMULTIPLE_TEXT      139
#define IDS_CANTTRASH_TEXT          140
#define IDS_OVERWRITEFOLDER_TEXT    141
#define IDS_OPEN_WITH               142
#define IDS_OPEN_WITH_CHOOSE        143
#define IDS_SHELL_ABOUT_AUTHORS     144
#define IDS_SHELL_ABOUT_BACK        145
#define FCIDM_SHVIEW_NEW            146
#define FCIDM_SHVIEW_VIEW           147
#define IDS_CONTROLPANEL            148
#define IDS_NEWFOLDER               149
#define IDS_COLUMN_EXTENSION        151
#define IDS_NO_EXTENSION            152
#define IDS_RECYCLEBIN_LOCATION     153
#define IDS_RECYCLEBIN_DISKSPACE    154
#define IDS_OPEN_WITH_FILTER        155
#define IDS_DIRECTORY               156
#define IDS_VIRTUAL_DRIVER          157
#define IDS_BAT_FILE                158
#define IDS_CMD_FILE                159
#define IDS_COM_FILE                160
#define IDS_CPL_FILE                161
#define IDS_CUR_FILE                162
#define IDS_DLL_FILE                163
#define IDS_DRV_FILE                164
#define IDS_EXE_FILE                165
#define IDS_FON_FILE                166
#define IDS_TTF_FILE                167
#define IDS_HLP_FILE                168
#define IDS_INI_FILE                169
#define IDS_LNK_FILE                170
#define IDS_SYS_FILE                171
#define IDS_EMPTY_BITBUCKET         172
#define IDS_SHLEXEC_NOASSOC         173
#define IDS_FILE_TYPES              174
#define IDS_FILE_DETAILS            175
#define IDS_FILE_DETAILSADV         176
#define IDS_BYTES_FORMAT            177
#define IDS_OPEN_WITH_RECOMMENDED   178
#define IDS_OPEN_WITH_OTHER         179

#define IDS_RUNDLG_ERROR            180
#define IDS_RUNDLG_BROWSE_ERROR     181
#define IDS_RUNDLG_BROWSE_CAPTION   182
#define IDS_RUNDLG_BROWSE_FILTER    183

#define IDS_UNKNOWN_APP             190
#define IDS_EXE_DESCRIPTION         191

#define IDS_OPEN_VERB               300
#define IDS_EXPLORE_VERB            301
#define IDS_RUNAS_VERB              302
#define IDS_EDIT_VERB               303
#define IDS_FIND_VERB               304
#define IDS_PRINT_VERB              305

#define IDS_FILE_FOLDER             308
#define IDS_CREATELINK              309
#define IDS_INSTALLNEWFONT          310
#define IDS_SHV_COLUMN_FONTTYPE     311
#define IDS_SHV_COLUMN12            312
#define IDS_SHV_COLUMN13            313
#define IDS_SHV_COLUMN_WORKGROUP    314
#define IDS_SHV_NETWORKLOCATION     315
#define IDS_COPY                    316
#define IDS_DELETE                  317
#define IDS_PROPERTIES              318
#define IDS_SHV_COLUMN_DOCUMENTS    319
#define IDS_SHV_COLUMN_STATUS       320
#define IDS_SHV_COLUMN_COMMENTS     321
#define IDS_SHV_COLUMN_LOCATION     322
#define IDS_SHV_COLUMN_MODEL        323
#define IDS_CUT                     324
#define IDS_RESTORE                 325
#define IDS_DEFAULT_CLUSTER_SIZE    326
#define IDS_FORMATDRIVE             328
#define IDS_RENAME                  329
#define IDS_INSERT                  330
#define IDS_DESCRIPTION             331
#define IDS_COPY_OF                 332

/* Note: those strings are referenced from the registry */
#define IDS_RECYCLEBIN_FOLDER_NAME  8964
#define IDS_ADMINISTRATIVETOOLS     22982
#define IDS_FOLDER_OPTIONS          22985
#define IDS_FONTS                   22981
#define IDS_PRINTERS                9319
#define IDS_MYCOMPUTER              9216
#define IDS_PERSONAL                9227
#define IDS_NETWORKPLACE            9217

/*
 * Dialogs
 */

/* Run dialog */
#define IDD_RUN                 1
#define IDC_RUNDLG_DESCRIPTION  12289
#define IDC_RUNDLG_BROWSE       12288
#define IDC_RUNDLG_ICON         12297
#define IDC_RUNDLG_EDITPATH     12298
#define IDC_RUNDLG_LABEL        12305

/* ShellAbout dialog */
#define IDD_ABOUT                   2
#define IDC_ABOUT_ICON              0x3009
#define IDC_ABOUT_APPNAME           0x3500
#define IDC_ABOUT_OTHERSTUFF        0x350D
#define IDC_ABOUT_REG_USERNAME      0x3507
#define IDC_ABOUT_REG_ORGNAME       0x3508
#define IDC_ABOUT_PHYSMEM           0x3503

/* About authors dialog */
#define IDD_ABOUT_AUTHORS           3
#define IDC_ABOUT_AUTHORS           0x4101
#define IDC_ABOUT_AUTHORS_LISTBOX   0x4102

/* Pick icon dialog */
#define IDD_PICK_ICON               4
#define IDC_PICKICON_LIST           0x4121
#define IDC_BUTTON_PATH             0x4122
#define IDC_EDIT_PATH               0x4123
#define IDS_PICK_ICON_TITLE         0x4124
#define IDS_PICK_ICON_FILTER        0x4125

/* Properties dialog */
#define IDD_FILE_PROPERTIES        8
#define IDD_FOLDER_PROPERTIES      9
#define IDD_DRIVE_PROPERTIES       10
#define IDD_DRIVE_TOOLS            11
#define IDD_DRIVE_HARDWARE         12
#define IDD_RECYCLE_BIN_PROPERTIES 13
#define IDD_SHORTCUT_PROPERTIES    14

/* File version */
#define IDD_FILE_VERSION 15

/* Shortcut */
#define IDD_SHORTCUT_EXTENDED_PROPERTIES 16

/* Folder Options */
#define IDD_FOLDER_OPTIONS_GENERAL   17
#define IDD_FOLDER_OPTIONS_VIEW      18
#define IDD_FOLDER_OPTIONS_FILETYPES 19

/* Yes to all msgbox */
#define IDD_YESTOALL_MSGBOX  20
#define IDC_YESTOALL         0x3207
#define IDC_YESTOALL_ICON    0x4300
#define IDC_YESTOALL_MESSAGE 0x4301

/* Browse for folder dialog box */
#define IDD_BROWSE_FOR_FOLDER             21
#define IDD_BROWSE_FOR_FOLDER_NEW         22
#define IDC_BROWSE_FOR_FOLDER_NEW_FOLDER  0x3746
#define IDC_BROWSE_FOR_FOLDER_FOLDER_TEXT 0x3745
#define IDC_BROWSE_FOR_FOLDER_FOLDER      0x3744
#define IDC_BROWSE_FOR_FOLDER_STATUS      0x3743
#define IDC_BROWSE_FOR_FOLDER_TITLE       0x3742
#define IDC_BROWSE_FOR_FOLDER_TREEVIEW    0x3741

/* Other dialogs */
#define IDD_RUN_AS               23
#define IDD_OPEN_WITH            24
#define IDD_FORMAT_DRIVE         25
#define IDD_CHECK_DISK           26

/* Not used dialogs */
#define IDD_FILE_COPY            27
#define IDD_SHUTDOWN             28
#define IDD_LOG_OFF              29
#define IDD_DISCONNECT           30
#define IDD_CONFIRM_FILE_REPLACE 31
#define IDD_AUTOPLAY1            32
#define IDD_MIXED_CONTENT1       33
#define IDD_MIXED_CONTENT2       34

/*
 * Icons
 */
#define IDI_SHELL_DOCUMENT           1
#define IDI_SHELL_RICH_TEXT          2
#define IDI_SHELL_EXE                3
#define IDI_SHELL_FOLDER             4
#define IDI_SHELL_FOLDER_OPEN        5
#define IDI_SHELL_5_12_FLOPPY        6
#define IDI_SHELL_3_14_FLOPPY        7
#define IDI_SHELL_FLOPPY             8
#define IDI_SHELL_DRIVE              9
#define IDI_SHELL_NETDRIVE          10
#define IDI_SHELL_NETDRIVE2         11
#define IDI_SHELL_CDROM             12
#define IDI_SHELL_RAMDISK           13
#define IDI_SHELL_ENTIRE_NETWORK    14
#define IDI_SHELL_NETWORK           15
#define IDI_SHELL_MY_COMPUTER       16
#define IDI_SHELL_PRINTER           17
#define IDI_SHELL_MY_NETWORK_PLACES 18
#define IDI_SHELL_COMPUTERS_NEAR_ME 19
#define IDI_SHELL_PROGRAMS_FOLDER   20
#define IDI_SHELL_RECENT_DOCUMENTS  21
#define IDI_SHELL_CONTROL_PANEL     22
#define IDI_SHELL_SEARCH            23
#define IDI_SHELL_HELP              24
#define IDI_SHELL_RUN               25
/* TODO: 26.ico, 27.ico */
#define IDI_SHELL_SHUTDOWN          28
#define IDI_SHELL_SHARE             29
#define IDI_SHELL_SHORTCUT          30
#define IDI_SHELL_FOLDER_OPEN_SMALL 31 /* ??? */
#define IDI_SHELL_EMPTY_RECYCLE_BIN 32
#define IDI_SHELL_FULL_RECYCLE_BIN  33
/* TODO: 34.ico */
#define IDI_SHELL_DESKTOP           35
#define IDI_SHELL_CONTROL_PANEL2    36
#define IDI_SHELL_PROGRAMS_FOLDER2  37
#define IDI_SHELL_PRINTERS_FOLDER   38
#define IDI_SHELL_FONTS_FOLDER      39
#define IDI_SHELL_TSKBAR_STARTMENU  40
#define IDI_SHELL_CD_MUSIC          41
/* TODO: 42.ico, 43.ico */
#define IDI_SHELL_FAVORITES         44
#define IDI_SHELL_LOGOFF            45
#define IDI_SHELL_EXPLORER          46
#define IDI_SHELL_UPDATE            47
#define IDI_SHELL_LOCKED            48
#define IDI_SHELL_NOT_CONNECTED_HDD 54
/* TODO: 133.ico */
#define IDI_SHELL_FIND_IN_FILE     134
#define IDI_SHELL_OPEN_WITH        135
#define IDI_SHELL_CONTROL_PANEL3   137
#define IDI_SHELL_PRINTER2         138
/* TODO: 139.ico, 140.ico, 141.ico */
#define IDI_SHELL_TRASH_FILE       142
/* TODO: 143.ico, 144,ico, 145.ico, 146.ico, 147.ico, 148.ico */
#define IDI_SHELL_INF_FILE         151
#define IDI_SHELL_TEXT_FILE        152
#define IDI_SHELL_BAT_FILE         153
#define IDI_SHELL_SYSTEM_FILE      154
#define IDI_SHELL_FONT_FILE        155
#define IDI_SHELL_TT_FONT_FILE     156
#define IDI_SHELL_FONT_FILE2       157
#define IDI_SHELL_RUN2             160
#define IDI_SHELL_CONFIRM_DELETE   161
/* TODO: 165.ico, 166.ico, 167.ico, 168.ico, 169.ico, 170.ico, 171.ico */
#define IDI_SHELL_NETWORK_FOLDER   172
#define IDI_SHELL_FAVORITES2       173
/* TODO: 174.ico, 175.ico, 176.ico, 177.ico, 178.ico, 179.ico, 180.ico, 181.ico */
#define IDI_SHELL_EMPTY_RECYCLE_BIN1 191
#define IDI_SHELL_FULL_RECYCLE_BIN1  192
/* TODO: 193.ico, 194.ico, 196.ico, 197.ico, 198.ico, 199.ico, 200.ico */
#define IDI_SHELL_FOLDER_OPTIONS   210
#define IDI_SHELL_USERS2           220
#define IDI_SHELL_TURN_OFF         221
#define IDI_SHELL_DVD_ROM          222
/* TODO: 223.ico */
#define IDI_SHELL_MOVIE_FILE       224
#define IDI_SHELL_MUSIC_FILE       225
#define IDI_SHELL_PICTURE_FILE     226
/* TODO: 227.ico */
#define IDI_SHELL_CD_MUSIC2        228
/* TODO: 229.ico, 230.ico, 231.ico, 232.ico */
#define IDI_SHELL_FDD              233
/* TODO: 234.ico */
#define IDI_SHELL_MY_DOCUMENTS     235
#define IDI_SHELL_MY_PICTURES      236
#define IDI_SHELL_MY_MUSIC         237
#define IDI_SHELL_MY_MOVIES        238
/* TODO: 239.ico */
#define IDI_SHELL_FULL_RECYCLE_BIN2 240
/* TODO: 241.ico, 242.ico, 243.ico, 244.ico */
#define IDI_SHELL_PRINTER3         245
#define IDI_SHELL_ICON_246         246
/* TODO: 247.ico */
#define IDI_SHELL_CAMERA           248
#define IDI_SHELL_SLIDE_SHOW       249
#define IDI_SHELL_DISPLAY          250
/* TODO: 251.ico */
#define IDI_SHELL_PRINT_PICS       252
/* TODO: 253.ico */
#define IDI_SHELL_EMPTY_RECYCLE_BIN3 254
#define IDI_SHELL_ICON_255         255
/* TODO: 256.ico, 257.ico, 258.ico, 259.ico, 260.ico, 261.ico, 262.ico */
#define IDI_SHELL_HELP1            263
/* TODO: 264.ico */
#define IDI_SHELL_SENDMAIL         265
/* TODO: 266.ico, 267.ico */
#define IDI_SHELL_ACCESSABILITY    268
#define IDI_SHELL_USERS            269
#define IDI_SHELL_SCREEN_COLORS    270
#define IDI_SHELL_ADD_REM_PROGRAMS 271
/* TODO: 272.ico, 273.ico, 274.ico, 275.ico, 276.ico */
#define IDI_SHELL_TUNES            277
/* TODO: 278.ico */
#define IDI_SHELL_USER_ACCOUNTS    279
/* TODO: 281.ico, 282.ico, 283.ico, 284.ico */
#define IDI_SHELL_HELP_FILE        289
#define IDI_SHELL_GO               290
#define IDI_SHELL_DVD_DRIVE        291
#define IDI_SHELL_CD_ADD_MUSIC     292
#define IDI_SHELL_CD               293
#define IDI_SHELL_CD_ROM           294
#define IDI_SHELL_CDR              295
#define IDI_SHELL_CDRW             296
#define IDI_SHELL_DVD_RAM          297
#define IDI_SHELL_DVDR_ROM         298
#define IDI_SHELL_MP3_PLAYER       299
/* TODO: 300.ico, 301.ico */
#define IDI_SHELL_CD_ROM1          302
/* TODO: 303.ico */
#define IDI_SHELL_DVD_ROM1         304
#define IDI_SHELL_FDD2             305
/* TODO: 306.ico, 307.ico, 308.ico */
#define IDI_SHELL_CAMERA1          309
/* TODO: 310.ico, 311.ico, 312.ico, 313.ico, 314.ico */
#define IDI_SHELL_SCANNER          315
/* TODO: 316.ico */
#define IDI_SHELL_CAMCORDER        317
#define IDI_SHELL_DVDRW_ROM        318
#define IDI_SHELL_NEW_FOLDER       319
/* TODO: 320.ico, 321.ico */
#define IDI_SHELL_FAVOTITES        322
#define IDI_SHELL_SEARCH1          323
#define IDI_SHELL_HELP2            324
#define IDI_SHELL_LOGOFF1          325
#define IDI_SHELL_PROGRAMS_FOLDER1 326
#define IDI_SHELL_RECENT_DOCUMENTS1 327
#define IDI_SHELL_RUN1             328
#define IDI_SHELL_SHUTDOWN1        329
#define IDI_SHELL_CONTROL_PANEL1   330
/* TODO: 331.ico, 337.ico, 338.ico, 512.ico */
#define IDI_SHELL_IDEA             1001
/* TODO: 1002.ico, 1003.ico */
#define IDI_SHELL_HELP_FILE1       1004
/* TODO: 1005.ico, 1006.ico, 1007.ico, 1008.ico, 1009.ico, 1010.ico, 1011.ico */
#define IDI_SHELL_SHUTDOWN2        8240

#define IDI_SHELL_DELETE1  16710
#define IDI_SHELL_DELETE2  16715
#define IDI_SHELL_DELETE3  16717
#define IDI_SHELL_DELETE4  16718
#define IDI_SHELL_DELETE5  16721

// Icons for Folder Options (ID's identical to Windows XP SP3)
#define IDI_SHELL_SHOW_COMMON_TASKS    182
#define IDI_SHELL_CLASSIC_FOLDERS      183
#define IDI_SHELL_OPEN_IN_SOME_WINDOW  184
#define IDI_SHELL_OPEN_IN_NEW_WINDOW   185
#define IDI_SHELL_SINGLE_CLICK_TO_OPEN 186
#define IDI_SHELL_DOUBLE_CLICK_TO_OPEN 187

/*
 * AVI resources
 *
 * windows shell32 has 14 of them: 150-152 and 160-170
 * FIXME: Need to add them, but for now just let them use the same: searching.avi
 * (also to limit shell32's size)
 */
#define IDR_AVI_SEARCH             150
#define IDR_AVI_SEARCHING          151
#define IDR_AVI_FINDCOMPUTER       152
#define IDR_AVI_FILEMOVE           160
#define IDR_AVI_FILECOPY           161
#define IDR_AVI_FILENUKE           163
#define IDR_AVI_FILEDELETE         164

/*
 * Shell view commands
 */
#define FCIDM_SHVIEW_ARRANGE    0x7001
#define FCIDM_SHVIEW_DELETE     0x7011
#define FCIDM_SHVIEW_PROPERTIES 0x7013
#define FCIDM_SHVIEW_CUT        0x7018
#define FCIDM_SHVIEW_COPY       0x7019
#define FCIDM_SHVIEW_INSERT     0x701A
#define FCIDM_SHVIEW_UNDO       0x701B
#define FCIDM_SHVIEW_INSERTLINK 0x701C
#define FCIDM_SHVIEW_SELECTALL  0x7021
#define FCIDM_SHVIEW_INVERTSELECTION 0x7022

#define FCIDM_SHVIEW_BIGICON    0x7029 //FIXME
#define FCIDM_SHVIEW_SMALLICON  0x702A //FIXME
#define FCIDM_SHVIEW_LISTVIEW   0x702B //FIXME
#define FCIDM_SHVIEW_REPORTVIEW 0x702C //FIXME
/* 0x7030-0x703f are used by the shellbrowser */
#define FCIDM_SHVIEW_AUTOARRANGE 0x7031
#define FCIDM_SHVIEW_SNAPTOGRID 0x7032

#define FCIDM_SHVIEW_HELP       0x7041
#define FCIDM_SHVIEW_RENAME     0x7050
#define FCIDM_SHVIEW_CREATELINK 0x7051
#define FCIDM_SHVIEW_NEWLINK    0x7052
#define FCIDM_SHVIEW_NEWFOLDER  0x7053

#define FCIDM_SHVIEW_REFRESH    0x7100 /* FIXME */
#define FCIDM_SHVIEW_EXPLORE    0x7101 /* FIXME */
#define FCIDM_SHVIEW_OPEN       0x7102 /* FIXME */

#define FCIDM_TB_UPFOLDER       0xA001
#define FCIDM_TB_NEWFOLDER      0xA002
#define FCIDM_TB_SMALLICON      0xA003
#define FCIDM_TB_REPORTVIEW     0xA004
#define FCIDM_TB_DESKTOP        0xA005  /* FIXME */

/*
 * Registrar scripts (RGS)
 */
#define IDR_ADMINFOLDERSHORTCUT 128
#define IDR_AUTOCOMPLETE        129
#define IDR_CONTROLPANEL        130
#define IDR_DRAGDROPHELPER      131
#define IDR_FOLDEROPTIONS       132
#define IDR_FOLDERSHORTCUT      133
#define IDR_FONTSFOLDERSHORTCUT 134
#define IDR_MENUBANDSITE        135
#define IDR_MYCOMPUTER          136
#define IDR_MYDOCUMENTS         137
#define IDR_NETWORKPLACES       138
#define IDR_NEWMENU             139
#define IDR_PRINTERS            140
#define IDR_RECYCLEBIN          141
#define IDR_SHELLDESKTOP        142
#define IDR_SHELLFSFOLDER       143
#define IDR_SHELLLINK           144
#define IDR_STARTMENU           145
#define IDR_OPENWITHMENU        146
#define IDR_FILEDEFEXT          147
#define IDR_DRVDEFEXT           148

#endif
