/* $Id: halinit_xbox.c 53675 2011-09-10 18:58:01Z tkreuzer $
 *
 * COPYRIGHT:     See COPYING in the top level directory
 * PROJECT:       ReactOS kernel
 * FILE:          ntoskrnl/hal/x86/halinit.c
 * PURPOSE:       Initalize the x86 hal
 * PROGRAMMER:    David Welch (welch@cwcom.net)
 * UPDATE HISTORY:
 *              11/06/98: Created
 */

/* INCLUDES *****************************************************************/

#include "halxbox.h"

#define NDEBUG
#include <debug.h>

const USHORT HalpBuildType = HAL_BUILD_TYPE;

/* FUNCTIONS ***************************************************************/

VOID
NTAPI
HalpInitProcessor(
    IN ULONG ProcessorNumber,
    IN PLOADER_PARAMETER_BLOCK LoaderBlock)
{
    /* Set default IDR */
    KeGetPcr()->IDR = 0xFFFFFFFB;
}

VOID
HalpInitPhase0(PLOADER_PARAMETER_BLOCK LoaderBlock)
{
    HalpXboxInitPartIo();
}

VOID
HalpInitPhase1(VOID)
{
}

/* EOF */
