GENDIB_BASE = $(TOOLS_BASE_)gendib
GENDIB_BASE_ = $(GENDIB_BASE)$(SEP)
GENDIB_INT = $(INTERMEDIATE_)$(GENDIB_BASE)
GENDIB_INT_ = $(GENDIB_INT)$(SEP)
GENDIB_OUT = $(OUTPUT_)$(GENDIB_BASE)
GENDIB_OUT_ = $(GENDIB_OUT)$(SEP)

$(GENDIB_INT): | $(TOOLS_INT)
	$(ECHO_MKDIR)
	${mkdir} $@

ifneq ($(INTERMEDIATE),$(OUTPUT))
$(GENDIB_OUT): | $(TOOLS_OUT)
	$(ECHO_MKDIR)
	${mkdir} $@
endif

GENDIB_TARGET = \
	$(GENDIB_OUT_)gendib$(EXEPOSTFIX)

GENDIB_SOURCES = \
	$(GENDIB_BASE_)gendib.c

GENDIB_OBJECTS = \
    $(addprefix $(INTERMEDIATE_), $(GENDIB_SOURCES:.c=.o))

GENDIB_HOST_CFLAGS = $(TOOLS_CFLAGS)

GENDIB_HOST_LFLAGS = $(TOOLS_LFLAGS)

$(GENDIB_TARGET): $(GENDIB_OBJECTS) | $(GENDIB_OUT)
	$(ECHO_HOSTLD)
	${host_gcc} $(GENDIB_OBJECTS) $(GENDIB_HOST_LFLAGS) -o $@

$(GENDIB_INT_)gendib.o: $(GENDIB_BASE_)gendib.c | $(GENDIB_INT)
	$(ECHO_HOSTCC)
	${host_gcc} $(GENDIB_HOST_CFLAGS) -c $< -o $@

.PHONY: gendib
gendib: $(GENDIB_TARGET)

.PHONY: gendib_clean
gendib_clean:
	-@$(rm) $(GENDIB_TARGET) $(GENDIB_OBJECTS) 2>$(NUL)
clean: gendib_clean

GENDIB_DIB_DIR = $(INTERMEDIATE_)subsystems$(SEP)win32$(SEP)win32k$(SEP)dib

GENDIB_DIB_FILES = \
	$(GENDIB_DIB_DIR)$(SEP)dib32gen.c \
	$(GENDIB_DIB_DIR)$(SEP)dib16gen.c \
	$(GENDIB_DIB_DIR)$(SEP)dib8gen.c

$(GENDIB_DIB_FILES): $(GENDIB_TARGET)
	${mkdir} $(GENDIB_DIB_DIR) 2>$(NUL)
	$(ECHO_GENDIB)
	$(Q)$(GENDIB_TARGET) $(GENDIB_DIB_DIR)
