PIPETOOLS_BASE = $(TOOLS_BASE)$(SEP)pipetools
PIPETOOLS_BASE_ = $(PIPETOOLS_BASE)$(SEP)
PIPETOOLS_INT = $(INTERMEDIATE_)$(PIPETOOLS_BASE)
PIPETOOLS_INT_ = $(PIPETOOLS_INT)$(SEP)
PIPETOOLS_OUT = $(OUTPUT_)$(PIPETOOLS_BASE)
PIPETOOLS_OUT_ = $(PIPETOOLS_OUT)$(SEP)

$(PIPETOOLS_INT): | $(TOOLS_INT)
	$(ECHO_MKDIR)
	${mkdir} $@

ifneq ($(INTERMEDIATE),$(OUTPUT))
$(PIPETOOLS_OUT): | $(TOOLS_OUT)
	$(ECHO_MKDIR)
	${mkdir} $@
endif


PIPETOOLS_TARGET = \
	$(PIPETOOLS_OUT_)piperead$(EXEPOSTFIX)

PIPETOOLS_SOURCES = \
	$(PIPETOOLS_BASE_)piperead.cpp

PIPETOOLS_OBJECTS = \
	$(addprefix $(INTERMEDIATE_), $(PIPETOOLS_SOURCES:.cpp=.o))

PIPETOOLS_HOST_CFLAGS = $(TOOLS_CFLAGS)

PIPETOOLS_HOST_LFLAGS = $(TOOLS_LFLAGS)

.PHONY: pipetools
pipetools: $(PIPETOOLS_TARGET)

$(PIPETOOLS_TARGET): $(PIPETOOLS_OBJECTS) | $(PIPETOOLS_OUT)
	$(ECHO_HOSTLD)
	${host_gcc} $(PIPETOOLS_OBJECTS) $(PIPETOOLS_HOST_LFLAGS) -o $@

$(PIPETOOLS_INT_)piperead.o: $(PIPETOOLS_BASE_)piperead.cpp | $(PIPETOOLS_INT)
	$(ECHO_HOSTCC)
	${host_gcc} $(PIPETOOLS_HOST_CFLAGS) -c $< -o $@


.PHONY: pipetools_clean
pipetools_clean:
	-@$(rm) $(PIPETOOLS_TARGET) $(PIPETOOLS_OBJECTS) 2>$(NUL)
clean: pipetools_clean
