using System;
using System.IO;
using System.Collections.Generic;
using System.Text;

using SysGen.RBuild.Framework;

namespace SysGen.BuildEngine.Framework
{
    public abstract class AutoGeneratedInfFileWriter : AutoGeneratedFileWriter
    {
        public AutoGeneratedInfFileWriter(RBuildProject project, string file)
            : base(project , file)
        {
        }

        protected virtual void WriteHeader()
        {
            WriteSection("Version");
            WriteLine("Signature = \"$Windows NT$\"");
            WriteLine("ClassGUID = {00000000-0000-0000-0000-000000000000}");
            WriteLine();
        }

        protected void WriteSection(string sectionName)
        {
            WriteLine("[{0}]", sectionName);
        }

        protected void WriteComment (string comment)
        {
            WriteLine("; {0}", comment);
        }

        protected void WriteAssignment(string name , string value)
        {
            WriteLine("{0} = {1}", 
                name , 
                value);
        }

        protected void WriteBooleanAssignment(string name, bool value)
        {
            if (value)
            {
                WriteAssignment(name, "yes");
            }
            else
            {
                WriteAssignment(name, "no");
            }
        }
    }
}