using System;
using System.IO;
using System.Collections.Generic;
using System.Text;

using SysGen.RBuild.Framework;

namespace SysGen.BuildEngine.Framework
{
    public class HeaderCreditsFileWriter : AutoGeneratedFileWriter
    {
        public HeaderCreditsFileWriter(RBuildProject project, string file)
            : base(project , file)
        {
        }

        public override void WriteFile()
        {
            WriteLine("/* This file is autogenerated */");
            WriteLine();
            WriteLine("const char* szAutoContributors[]=");
            WriteLine("{");

            foreach (RBuildContributor contributor in Project.Contributors)
            {
                WriteLine("\t\t{0},", contributor.FullName);
            }

            WriteLine("\t0");
            WriteLine("};");

            // Adds a blank line
            WriteLine();
        }
    }
}
