using System;
using System.IO;
using System.Collections.Generic;
using System.Text;

using SysGen.RBuild.Framework;

namespace SysGen.BuildEngine.Framework
{
    public class TxtCreditsFileWriter : AutoGeneratedFileWriter
    {
        public TxtCreditsFileWriter(RBuildProject project, string file)
            : base(project , file)
        {
        }

        public override void WriteFile()
        {
            WriteLine("ReactOS is available thanks to the work of:");
            WriteLine();

            foreach (RBuildContributor contributor in Project.Contributors)
            {
                if (contributor.HasAlias)
                {
                    WriteLine("\t{0} ({1})",
                        contributor.FullName,
                        contributor.Alias);
                }
                else
                {
                    WriteLine("\t{0}", contributor.FullName);
                }

                if (contributor.HasMail)
                {
                    WriteLine("\t\t{0}", contributor.Mail);
                }

                if (contributor.HasLocation)
                {
                    WriteLine("\t\t{0}, {1}", 
                        contributor.City , 
                        contributor.Country);
                }

                // Adds a blank line
                WriteLine();
            }
        }
    }
}
